#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <curl/curl.h>
#include "parser.h"

#define maxV 8192
#define maxS 512

static size_t write_data (void *ptr, size_t size, size_t nmemb, void *stream)
{
    int written = fwrite(ptr, size, nmemb, (FILE *)stream);
    return written;
}

int crawler (char* domain, Digraph G)
{
    CURL *curl_handle;
    FILE *headerfile;
    FILE *bodyfile;
    static const char *headerfilename = "head.out";
    static const char *bodyfilename = "body.out";

    FILE* IN;
    FILE* OUT;

    char** URL;
    char link[512];
    int u;
    int n;
    int start, end;
    CURLcode res;

    curl_global_init(CURL_GLOBAL_ALL);
    curl_handle = curl_easy_init();

    URL = malloc(maxV * sizeof(char*));
    for (n = 0; n < maxV; n++) {
        URL[n] = calloc(maxS, sizeof(char));
    }
    

    strcpy(url[0], domain);
    strcpy(link, domain);
    
    u = DIGRAPHinsertURL(G, link); /* vai inserir na posicao 0 e u = 0 */
    n = 100;
    start = 0;
    end = 1;

    /* comeca a pegaras páginas */
    while (u < maxV-1 && u < n) {
        
        if (u != 0) {
            strcpy(link, "");
            strcat(link, url[0]);
            strcat(link, url[u]);
        }

        curl_easy_setopt(curl_handle, CURLOPT_URL, link);
        curl_easy_setopt(curl_handle, CURLOPT_NOPROGRESS, 1L);
        curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, write_data);

        /* open the files */
        headerfile = fopen(headerfilename,"w");
        if (headerfile == NULL) {
            curl_easy_cleanup(curl_handle);
            return -1;
        }

        bodyfile = fopen(bodyfilename,"w");
        if (bodyfile == NULL) {
            curl_easy_cleanup(curl_handle);
            return -1;
        }

        curl_easy_setopt(curl_handle, CURLOPT_WRITEHEADER, headerfile);
        curl_easy_setopt(curl_handle, CURLOPT_WRITEDATA, bodyfile);
        res = curl_easy_perform(curl_handle);
        fclose(headerfile);
        fclose(bodyfile);

        if (res == CURLE_OK) {
            IN = fopen("body.out", "r");
            start = end;
            end = parse_to_ed(IN, url, DIGRAPHhash_lookup(URL[u], G), end);
            fclose(IN);
        }

        u++;
    }

    curl_easy_cleanup(curl_handle);
    return 0;
}

