#include "parser.h"

int contains (char**, char*);

/*
int main (int argc, char *argv[])
{
    int i, j;
    FILE* input;
    char** URL;
    URL = malloc(4096 * sizeof(char*));
    for (j = 0; j < 4096; j++) {
        URL[j] = calloc(512, sizeof(char));
    }
    for (i = 1; i < argc; i++) {
        input = fopen(argv[i], "r");
        if (input == NULL) {
            printf("Failed to open file <%s>\n", argv[i]);
        }
        
        else {
            printf("FILE: %s\n", argv[i]);
            printf("Antes do parser\n");
            parse_to_ed(input, URL);
            printf("Depois do parser\n");
            fclose(input);
        }
    }

    for (i = 0; strcmp(URL[i], "") != 0; i++) {
        printf("URL[%d] = %s\n", i, URL[i]);
    }

    for (j = 0; j < 4096; j++) {
        free(URL[j]);
    }
    free(URL);

    printf("\n");
    return 0;
}
*/

void parse_to_url (FILE* input, FILE* output)
{
    char buf1[512];
    char buf2[512];
    int i = 0;
    int j;
    int skip;
    char ch = '\0';

    fscanf(input, "%c%c", &buf1[0], &buf1[1]);
    buf1[2] = '\0';
    while (!feof(input)) {
        /* Procurar uma tag de link <a */
        if (strcmp(buf1, "<a") == 0) {
            j = 0;
            skip = 0;

            /* Checar o fim da tag, isto e, o char '>' */
            fscanf(input, "%c", &ch);
            while (!feof(input) && ch != '>') {
                fscanf(input, "%c", &ch);
                buf2[j++] = ch;                
            }

            /* Retirar a string "href=" do inicio */
            buf2[j] = '\0';
            for (j = 0, ch = buf2[0]; ch != '='; ch = buf2[++j]);
            if (isspace(buf2[j + 1])) j++;
            skip = j + 1;
            for (ch = buf2[++j]; (!isspace(ch) && ch != '>'); ch = buf2[++j]);
            buf2[j] = '\0';

            /* Retirar as aspas, se houver */
            if (buf2[skip] == '"') {
                skip++;
                for (i = skip; i < strlen(buf2); i++) {
                    if (buf2[i] == '"') buf2[i] = '\0';
                }
            }

            /* Deixar apenas o caminho relativo ao dominio dado */
            if (buf2[skip] != '/') {
                if (strncmp((buf2 + skip), "http://www.ime.usp.br", strlen("http://www.ime.usp.br")) == 0) {
                    skip += strlen("http://www.ime.usp.br");
                }
                else if (strncmp((buf2 + skip), "www.ime.usp.br", strlen("www.ime.usp.br")) == 0) {
                    skip += strlen("www.ime.usp.br");
                }
                else if (strncmp((buf2 + skip), "ime.usp.br", strlen("ime.usp.br")) == 0) {
                    skip += strlen("ime.usp.br");
                }
            }
            if (buf2[skip] == '/') {
                fprintf(output, "%s\n", (buf2 + skip));
            }
        }
        if (!feof(input)) {
            buf1[0] = buf1[1];
            fscanf(input, "%c", &buf1[1]);
        }
    }
}

int parse_to_ed (FILE* input, char** URL, int v, int free)
{
    char buf1[512];
    char buf2[512];
    int i = 0;
    int j;
    int skip;
    char ch = '\0';

    fscanf(input, "%c%c", &buf1[0], &buf1[1]);
    buf1[2] = '\0';
    while (!feof(input)) {
        /* Procurar uma tag de link <a */
        if (strcmp(buf1, "<a") == 0) {
            j = 0;
            skip = 0;

            /* Checar o fim da tag, isto e, o char '>' */
            fscanf(input, "%c", &ch);
            while (!feof(input) && ch != '>') {
                fscanf(input, "%c", &ch);
                buf2[j++] = ch;                
            }

            /* Retirar a string "href=" do inicio */
            buf2[j] = '\0';
            for (j = 0, ch = buf2[0]; ch != '='; ch = buf2[++j]);
            if (isspace(buf2[j + 1])) j++;
            skip = j + 1;
            for (ch = buf2[++j]; (!isspace(ch) && ch != '>'); ch = buf2[++j]);
            buf2[j] = '\0';

            /* Retirar as aspas, se houver */
            if (buf2[skip] == '"') {
                skip++;
                for (i = skip; i < strlen(buf2); i++) {
                    if (buf2[i] == '"') buf2[i] = '\0';
                }
            }

            /* Deixar apenas o caminho relativo ao dominio dado */
            if (buf2[skip] != '/') {
                if (strncmp((buf2 + skip), "http://www.ime.usp.br", strlen("http://www.ime.usp.br")) == 0) {
                    skip += strlen("http://www.ime.usp.br");
                }
                else if (strncmp((buf2 + skip), "www.ime.usp.br", strlen("www.ime.usp.br")) == 0) {
                    skip += strlen("www.ime.usp.br");
                }
                else if (strncmp((buf2 + skip), "ime.usp.br", strlen("ime.usp.br")) == 0) {
                    skip += strlen("ime.usp.br");
                }
            }

            if (buf2[skip] == '/') {
                if (strlen((buf2 + skip)) > 1) {
                    if ((w = hash_lookup(G, (buf2 + skip))) == -1) {
                        /* Fazer a função INSERT URL (ela tem que fazer hash_in */
                        w = DIGRAPHinsertURL(G, (buf2 + skip));
                    }
                    DIGRAPHinsertA(G, v, w);
                    strcpy(URL[free++], (buf2 + skip));
                }
            }
        }

        if (!feof(input)) {
            buf1[0] = buf1[1];
            fscanf(input, "%c", &buf1[1]);
        }
    }
    return free;
}

int contains (char** URL, char* target)
{
    int i;
    for (i = 0; strcmp(URL[i], "") != 0; i++) {
        if (strcmp(URL[i], target) == 0) {
            return 1;
        }
    }
    return 0;
}
